##############################################################################
#
# SubPlone - Simple, nested sites to go
# Copyright (C) 2005 Sidnei da Silva and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: __init__.py 8663 2005-05-23 16:32:15Z dreamcatcher $
"""

from Products.Archetypes.public import listTypes, process_types
from Products.CMFCore.utils import ContentInit
from Products.CMFCore.DirectoryView import registerDirectory
from Products.SubPlone.config import *

# Make sure Install imports
from Products.SubPlone.Extensions import Install
del Install

registerDirectory('skins', GLOBALS)

def initialize(context):
    """Initialize Product
    """
    from Products.SubPlone.content import site
    from Products.SubPlone.utils import groupTypesByPerm
    from Products.SubPlone.permissions import perm_map
    from Products.SubPlone.permissions import setDefaultRoles
    from Products.SubPlone.permissions import AddReference

    setDefaultRoles(AddReference, ('Manager',))

    listOfTypes = listTypes(PROJECTNAME)
    content_types, constructors, ftis = process_types(listOfTypes, PROJECTNAME)

    # separate out the content types so we can register them in groups
    # based on permissions

    type_map = groupTypesByPerm(
        listOfTypes,
        content_types,
        constructors,
        perm_map
        )

    for permission in type_map:
        factory_info = type_map[permission]
        content_types = tuple([fi[0] for fi in factory_info])
        constructors  = tuple([fi[1] for fi in factory_info])

        # Register Content
        ContentInit(
            PROJECTNAME + ' Content',
            content_types=content_types,
            permission=permission,
            extra_constructors=constructors,
            fti=ftis,
            ).initialize(context)

    # Register Policy
    import policy
    policy.register(context, GLOBALS)
