##############################################################################
#
# SubPlone - Simple, nested sites to go
# Copyright (C) 2005 Sidnei da Silva and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: registry.py 8663 2005-05-23 16:32:15Z dreamcatcher $
"""

from UserDict import UserDict
from Globals import InitializeClass
from Products.SubPlone.permissions import ManagePortal, View
from AccessControl import ModuleSecurityInfo, ClassSecurityInfo

msi = ModuleSecurityInfo('Products.SubPlone.registry')
msi.declarePublic('RefRegistry')

class RegistryItem:

    security = ClassSecurityInfo()
    ok = {'info': 1}
    security.setDefaultAccess(ok)

    def __init__(self, name, title, factory):
        self.name = name
        if not title:
            title = name
        self.title = title
        self.factory = factory

    def info(self):
        return {'name':self.name,
                'title':self.title}

    def create(self, *args, **kw):
        return self.factory(*args, **kw)

InitializeClass(RegistryItem)

class Registry(UserDict):

    security = ClassSecurityInfo()
    ok = {'items': 1,
          'values': 1,
          'keys': 1}
    security.setDefaultAccess(ok)

    def register(self, name, title, factory):
        self[name] = RegistryItem(name, title, factory)

InitializeClass(Registry)

RefRegistry = Registry()
