##############################################################################
#
# SubPlone - Simple, nested sites to go
# Copyright (C) 2005 Sidnei da Silva and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: base.py 8663 2005-05-23 16:32:15Z dreamcatcher $
"""

import sys
from cStringIO import StringIO
from pprint import pprint
from difflib import unified_diff

# Load fixture
from Testing import ZopeTestCase

# Install our product
ZopeTestCase.installProduct('ZCatalog')
ZopeTestCase.installProduct('PortalTransforms')
ZopeTestCase.installProduct('MimetypesRegistry')
ZopeTestCase.installProduct('Archetypes')
ZopeTestCase.installProduct('SubPlone')
#ZopeTestCase.installProduct('VerboseSecurity')

from Products.CMFPlone.tests import PloneTestCase
from utils import populateFolder

from zExceptions.ExceptionFormatter import format_exception
from ZPublisher.HTTPResponse import HTTPResponse

# Silence Plone's handling of exceptions
orig_exception = HTTPResponse.exception
def exception(self, **kw):
    def tag_search(*args):
        return False
    kw['tag_search'] = tag_search
    return orig_exception(self, **kw)

orig_setBody = HTTPResponse.setBody
def setBody(self, *args, **kw):
    kw['is_error'] = 0
    if len(args[0]) == 2:
        title, body = args[0]
        args = (body,) + args[1:]
    return orig_setBody(self, *args, **kw)

def _traceback(self, t, v, tb, as_html=1):
    return ''.join(format_exception(t, v, tb, as_html=as_html))

HTTPResponse._error_format = 'text/plain'
HTTPResponse._traceback = _traceback
HTTPResponse.exception = exception
HTTPResponse.setBody = setBody

class BaseTest(PloneTestCase.PloneTestCase):

    def afterSetUp(self):
        pass

    def assertStructEquals(self, got, expected):
        _got = StringIO()
        _expected = StringIO()
        pprint(got, _got)
        pprint(expected, _expected)
        _got = _got.getvalue().splitlines()
        _expected = _expected.getvalue().splitlines()
        diff = unified_diff(_expected, _got)
        self.failUnless(got == expected, '\n'.join(diff))
