##############################################################################
#
# SubPlone - Simple, nested sites to go
# Copyright (C) 2005 Sidnei da Silva and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: test_doctests.py 9028 2005-06-10 14:25:49Z dreamcatcher $
"""

import os, sys

if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

# Load fixture
from Testing import ZopeTestCase
from Testing.ZopeTestCase import doctest
from cStringIO import StringIO

from Products.CMFCore.utils import getToolByName
from Products.SubPlone.tests import utils
from Products.SubPlone.tests.base import BaseTest

class FunctionalTest(ZopeTestCase.Functional, BaseTest):

    def afterSetUp(self):
        BaseTest.afterSetUp(self)
        self.loginPortalOwner()

class SiteTest(FunctionalTest):

    def afterSetUp(self):
        FunctionalTest.afterSetUp(self)
        self.qi = getToolByName(self.portal, 'portal_quickinstaller')
        self.qi.installProduct('Archetypes')
        self.qi.installProduct('SubPlone')

def test_suite():
    import unittest
    suite = unittest.TestSuite()
    functional = (
        (FunctionalTest, 'proxy.txt'),
        (FunctionalTest, 'skin.txt'),
        (FunctionalTest, 'blocker.txt'),
        (SiteTest, 'uid.txt'),
        (SiteTest, 'site.txt'),
        )
    for klass, docfile in functional:
        suite.addTest(
            doctest.FunctionalDocFileSuite(docfile,
                                           test_class=klass,
                                           package='Products.SubPlone.tests'))

    doctests = (
        'Products.SubPlone.utils',
        )
    for module in doctests:
        suite.addTest(doctest.DocTestSuite(module))

    return suite

if __name__ == '__main__':
    framework(descriptions=0, verbosity=1)
