##############################################################################
#
# SubPlone - Simple, nested sites to go
# Copyright (C) 2005 Sidnei da Silva and contributors
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of the
# License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
##############################################################################
"""
$Id: test_security.py 8663 2005-05-23 16:32:15Z dreamcatcher $
"""

import os, sys, textwrap

if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

# Load fixture
from Testing import ZopeTestCase
from Products.SubPlone.tests import base

from Products.CMFPlone.tests import testSecurityDeclarations as sec

class SecurityDeclarationsTest(sec.RestrictedPythonTest):

    # NOTE: This test case is a bit hairy. Security declarations
    # "stick" once a module has been imported into the restricted
    # environment. Therefore the tests are not truly independent.
    # Be careful when adding new tests to this class.

    def check(self, body):
        body = textwrap.dedent(body)
        return sec.RestrictedPythonTest.check(self, body)

    def checkUnauthorized(self, body):
        body = textwrap.dedent(body)
        return sec.RestrictedPythonTest.checkUnauthorized(self, body)

    def test_registry_items(self):
        self.check(
            """
            from Products.SubPlone.registry import RefRegistry
            return RefRegistry.items()
            """)

    def test_registry_keys(self):
        self.check(
            """
            from Products.SubPlone.registry import RefRegistry
            return RefRegistry.keys()
            """)

    def test_registry_values(self):
        self.check(
            """
            from Products.SubPlone.registry import RefRegistry
            return RefRegistry.values()
            """)

    def test_registry_register_unauthorized(self):
        self.checkUnauthorized(
            """
            from Products.SubPlone.registry import RefRegistry
            RefRegistry.register('name', 'title', 'bla')
            """)

    def test_registry_update__unauthorized(self):
        self.checkUnauthorized(
            """
            from Products.SubPlone.registry import RefRegistry
            RefRegistry.update({'a': 'b'})
            """)

    def test_registry_item_info(self):
        self.check(
            """
            from Products.SubPlone.registry import RefRegistry
            return [r.info() for r in RefRegistry.values()]
            """)

    def test_registry_item_name(self):
        self.checkUnauthorized(
            """
            from Products.SubPlone.registry import RefRegistry
            item = RefRegistry.values()[0]
            return item.name
            """)

def test_suite():
    import unittest
    suite = unittest.TestSuite()
    for klass in (
        SecurityDeclarationsTest,
        ):

        suite.addTest(unittest.makeSuite(klass))
    return suite

if __name__ == '__main__':
    framework(descriptions=0, verbosity=1)
